/* example arexx script to control the SuperGen genlock device. */
/* by Bob Dickow */

/* ...actually, this simply interfaces the CLI to the command host via  */
/* AREXX. It could also be used from programs such as The Director,     */
/* using its EXECUTE command.                                           */

/* To use this with arexx, type: rx genlock.gen <command> [arg1...arg4] */
/* N.B. Don't forget to first run the command host program (genlock).   */
/* The available commands are:                                          */

/*         ON BackGroundValue BGnoVB GraphicsValue GnoVB                */
/*          ( BackGroundValue and GraphicsValue may range from 0 to 63  */
/*            BGnoVB and GnoVB, if positive and >0, specify a rate      */
/*            to ramp to the specified value from the previously set    */
/*            value. So, to fade in the amiga graphics and fade out the */
/*            video image, you would type <0 200 0 200>. Try changing   */
/*            the 200's for different speeds. If BGnoVB and/or GnoVB    */
/*            are zero, the change is immediate. If they are negative,  */
/*            no change will take place. )                              */

/*        OFF BackGroundValue BGnoVB GraphicsValue GnoVB                */
/*          ( Using OFF instead of ON disables the software control of  */
/*            the genlock [the sliders will come back to life!] while   */
/*            still allowing you to change the internal values of the   */
/*            'software sliders' without affecting the video. )         */

/*        GENPRI [0 - 8]                                                */
/*          ( ...where 0 is minimum priority and 8 is maximum, this     */
/*            command sets the internal genlock priority. If the CALL   */
/*            PRIORITY (see below) is equal or greater to this value,   */
/*            the commands will have an effect, otherwise nothing will  */
/*            happen at all. This might be useful if you plan to have   */
/*            lots of different programs control the genlock at the     */
/*            same time. The default value is set to 8. If you leave    */
/*            the arguments off, the command host will return a result  */
/*            (if you set options results--see below) string specifying */
/*            the current priority setting.)                            */

/*        CALLPRI [0 - 8]                                               */
/*          ( Behaves much like GENPRI above, but affects the priority  */
/*            of the CALL's, or ON and OFF commands above. If the value */
/*            is below the GENLOCK PRIORITY (GENPRI) then the commands  */
/*            will not have an effect.)                                 */

/*        QUIT                                                          */
/*          ( tells the command host to clean up and exit to the CLI )  */

/* ******************************************************************** */

options results

address 'genlock'

parse upper arg a

if (LENGTH(a) > 0) then interpret a

if a = GENPRI then say 'The current genlock priority is' result
if a = CALLPRI then say 'The current call priority is'   result

exit

/*  END OF SCRIPT */
