
NAME
       FilTex - Filter text


SYNOPSIS
       FilTex <File | STDIN> [THRESH #] [NOLF] [NULT]


REQUIREMENTS
       The ARP library


DESCRIPTION
       FilTex reads a file, removes all non-text characters, and writes
       the result to the standard output.  The found chunks of text are
       terminated with linefeeds if they weren't already.
       FilTex recognizes most normal ASCII codes + TAB & LF as being text.
       The optional THRESH keyword may be followed by a number indicating
       the minimum number of subsequent text bytes required for FilTex to
       recognize a chunk of bytes as being text.  The default is 4.
       If you do not want the terminating linefeeds, specify the NOLF
       switch.
       The NULT option causes FilTex to pass only null-terminated strings.
       This option reduces the percentage of bogus strings FilTex finds.
       Still, not all text strings in a program file are guaranteed to be
       null-terminated.


EXAMPLES
       prompt> FilTex >Clues Adventure
       Find pieces of text in a program file.


BUGS/LIMITATIONS
       -FilTex does not recognize "@", "`", the extended ASCII values
        and most control codes as being text.  This improves the
        filter's selectivity.  If you need umlauts or whatever,
        look at the source and reassemble, or use a file-zapper and
        search for the string 'TextTab:'.  This string is followed
        directly by an array of 256 bytes, the Nth byte corresponding
        to the Nth ASCII code.  If the byte is nonzero, its location
        index will be recognized as a text value.  For zapping clarity,
        I've given each text location its (nonzero) ASCII value.
       -FilTex is only a very simple filter. It therefore passes through
        a lot of garbage text strings if you're filtering binary code.
        The NULT option improves the performance only slightly because
        your average binary code contains a lot of nulls.
