
NAME
       PForm - Pipe formatted lines.


SYNOPSIS
       PForm "prefix %[flags][width.limit]s postfix"


REQUIREMENTS
       The ARP library


DESCRIPTION
       PForm reads lines from the standard input, formats them to your
       specifications, and writes them to the standard output.
       The formatting is done using exec's DoRawFmt. This is C like string
       formatting. See programmer manuals for additional information.
       What matters here is that PForm outputs its argument line string
       for every input line, and it replaces every occurrence of %s in the
       argument line string with the current input line.
       The "width" argument specifies the fieldsize used when inserting the
       input line into the string, and "limit" specifies the maximum number
       of characters copied from the input line while inserting.
       The only valid flag is "-" which specifies left justification.
       You may use %s upto 20 times in a single format string.
       To get a single "%" use "%%".
       The main use for PForm lies in reformatting the output of commands.


EXAMPLES
       Alias Kill Status \| Search STDIN [] NONUM \| PForm "Break%11.10s" \| Execute
       This alias will break the process with the name you specify. You
       no longer need to specify the process number.

       List [] NOHEAD QUICK | PForm "Rename %s %s.old" | Execute
       Give commands wildcarding properties.


BUGS/LIMITATIONS
       How to apply PForm to the output of a command depends on the specific
       format of its output. You'd better experiment.
