
NAME
       Tee - pipe fitting


SYNOPSIS
       Tee [-a | APPEND] <File> [...]


REQUIREMENTS
       The ARP library


DESCRIPTION
       Tee copies the standard input to the standard output while making
       copies of it into one or more files. The -a or APPEND switch makes
       Tee append to old files instead of creating new files. If a target
       file does not exist, and -a has been selected, it will be created.


EXAMPLES
       prompt> Tee T:keys | QueryingTool
       prompt> QueryingTool <T:keys | Tee T:log
       This saves keystrokes destined for a CLI tool to a file, and
       reuses them whilst making a reference copy of the output.


BUGS/LIMITATIONS
       -Use the end-of-file control key specific to your shell to terminate
        if you run Tee as the first part of your pipe-command line.
       -Tee was modelled after one of the Unix-alike utilities distributed
        in a uusenet posting by David Gay. Tiny-Tee's functionality differs
        from that version in 3 ways:
        1. The -a switch can be substituted by an equivalent switch, namely
           'APPEND'.
        2. The ARP template needs switches to be specified after multiargs,
           still you may place the -a switch anywhere in the command line,
           thus it is up to you to preserve the Unix syntax (-a in front).
        3. David's Tee version does not seem to want to process non-ascii
           byte streams (this might be as intended). Tiny-Tee copies every
           byte you feed into it.
